'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _propertiesForElement2 = require('./propertiesForElement');

var _propertiesForElement3 = _interopRequireDefault(_propertiesForElement2);

var _arrayFlatten = require('array-flatten');

var _arrayFlatten2 = _interopRequireDefault(_arrayFlatten);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function describeReactElement(element) {
  var indentation = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

  var indention = ' '.repeat(indentation * 2);

  if (typeof element === 'string') {
    return '' + indention + element;
  }

  if (typeof element === 'undefined') {
    return;
  }
  if (element === false) {
    return;
  }

  var elementName = element.type.name || element.type;

  var _propertiesForElement = (0, _propertiesForElement3.default)(element),
      elementChildren = _propertiesForElement.children,
      elementProperties = _objectWithoutProperties(_propertiesForElement, ['children']);

  var properties = Object.keys(elementProperties).map(function (key) {
    return key + '=\'' + elementProperties[key] + '\'';
  });

  var tagIntroduction = [elementName].concat(_toConsumableArray(properties)).join(' ');

  if (elementChildren) {
    var children = (0, _arrayFlatten2.default)([elementChildren]);
    var childDescriptions = children.map(function (childElement) {
      return describeReactElement(childElement, indentation + 1);
    }).filter(function (description) {
      return typeof description === 'string';
    });

    return [indention + '<' + tagIntroduction + '>'].concat(_toConsumableArray(childDescriptions), [indention + '</' + elementName + '>']).join("\n");
  } else {
    return indention + '<' + tagIntroduction + ' />';
  }
}

exports.default = describeReactElement;